Loading...
Searching...
No Matches
BALL::GridedPLP Class Reference

`#include <BALL/SCORING/FUNCTIONS/gridedPLP.h>`

Inheritance diagram for BALL::GridedPLP:

## Public Member Functions

| GridedPLP (AtomContainer &receptor, AtomContainer &ligand, Options &options)
| GridedPLP (AtomContainer &receptor, Vector3 &hashgrid_origin, Options &options)
void | setLigand (AtomContainer *sys)
Public Member Functions inherited from BALL::DiffGridBasedScoring
| DiffGridBasedScoring (AtomContainer &receptor, AtomContainer &ligand, Options &options)
| DiffGridBasedScoring (AtomContainer &receptor, Vector3 &hashgrid_origin, Options &options)
| ~DiffGridBasedScoring ()=default
void | update ()
virtual double | updateScore ()
void | testOverlaps (Vector3 &position, HashGrid3< Atom * > *hashg=nullptr)
Public Member Functions inherited from BALL::GridBasedScoring
| GridBasedScoring (AtomContainer &receptor, AtomContainer &ligand, Options &options)
| GridBasedScoring (AtomContainer &receptor, Vector3 &hashgrid_origin, Options &options)
virtual | ~GridBasedScoring ()
void | defineGridSet (AtomContainer *sys, Vector3 &angstroem, double out_of_grid_penalty, bool enforce_grid_boundaries, double resolution, double interaction_no_scale=1)
void | defineGridSet (AtomContainer *sys, double out_of_grid_penalty, bool enforce_grid_boundaries, double resolution, double interaction_no_scale=1)
void | defineFlexibleResiduesGridSet ()
void | printResult ()
void | setAtomTypeNames (std::set< String > &types)
void | precalculateGrids (bool ony_flexRes_grids=false)
void | saveGridSetsToFile (String file, String receptor_name)
void | readAdditionalGridSetFromFile (String file)
void | replaceGridSetFromFile (String file)
void | loadFlexibleResidueScoreGrids (std::list< std::pair< const Residue *, const Rotamer * > > residue_list)
void | setupReferenceLigand ()
void | setCombineOperation (int i)
int | getNoNeighboringReceptorAtoms ()
std::vector< ScoreGridSet * > * | getScoreGridSets ()
void | validateGridSets ()
Public Member Functions inherited from BALL::ScoringFunction
| ScoringFunction ()
| ScoringFunction (const ScoringFunction &sf)
| ScoringFunction (AtomContainer &receptor, AtomContainer &ligand)
| ScoringFunction (AtomContainer &receptor, AtomContainer &ligand, const Options &options)
| ScoringFunction (AtomContainer &receptor, AtomContainer &ligand, Options &options)
| ScoringFunction (AtomContainer &receptor, Vector3 &hashgrid_origin, Options &options)
virtual | ~ScoringFunction ()
virtual void | clear ()
ScoringFunction & | operator= (const ScoringFunction &sf)
bool | setup ()
bool | setup (AtomContainer &receptor, AtomContainer &ligand)
bool | setup (AtomContainer &receptor, AtomContainer &ligand, const Options &options)
void | setMaximumNumberOfErrors (Size nr)
Size | getMaximumNumberOfErrors () const
void | setFirstMolecule (AtomContainer &molecule1)
AtomContainer * | getFirstMolecule () const
void | setSecondMolecule (AtomContainer &molecule2)
AtomContainer * | getSecondMolecule () const
void | setReceptor (AtomContainer &receptor)
AtomContainer * | getReceptor () const
void | setLigand (AtomContainer &ligand)
AtomContainer * | getLigand () const
void | setIntercept (double intercept)
double | getIntercept () const
void | setBaseFunction (ScoringBaseFunction &base_function)
| Set the instance of BaseFunction for the scoring function.
ScoringBaseFunction * | getBaseFunction () const
void | insertComponent (ScoringComponent *component)
void | insertComponent (ScoringComponent *component, float coefficient)
void | removeComponent (const ScoringComponent *component)
void | removeComponent (const String &name)
void | setCoefficient (const ScoringComponent *component, float coefficient)
void | setCoefficient (const String &name, float coefficient)
bool | getCoefficient (const ScoringComponent *component, float &coefficient) const
bool | getCoefficient (const String &name, float &coefficient) const
ScoringComponent * | getComponent (const String &name) const
ScoringComponent * | getComponent (const Size index) const
double | calculateScore ()
const HashSet< const Atom * > & | getUnassignedAtoms () const
HashSet< const Atom * > & | getUnassignedAtoms ()
double | getExpEnergyStddev ()
void | enableStoreInteractionsOnlyForPhContraints ()
String | convertTime (double seconds)
virtual void | printResult (bool detail=0)
void | getScoreContributions (vector< double > &score_contributions, vector< String > &names)
String | getEquation ()
void | enableStoreInteractions (bool b=true)
String | getName ()
int | getBurialDepthScale ()
String | valueToString (double value)
void | unsetTrainingParameters ()
void | setNormalizationParameters (double stddev, double mean)
const HashGrid3< Atom * > * | getHashGrid ()
const Vector3 & | getLigandCenter () const
double | getLigandRadius () const
bool | storeInteractionsEnabled ()
int | getNoLigandAtoms ()
Options | getOptions ()
Options * | getOptionsToModify ()
void | createStaticLigandFragments ()
const vector< Bond * > * | getRotatableLigandBonds () const
const vector< StaticLigandFragment * > * | getStaticLigandFragments () const
bool | hasFlexibleResidues ()
void | setFlexibleResidues (const std::set< Residue * > &flexible_residues)
bool | assignRotamer (Residue *residue, ResidueRotamerSet *rotamer_set, const Rotamer *rotamer)
void | resetFlexibleResidues ()
Size | countNeighboringReceptorAtoms (const Atom *atom, double distance_threshold, bool onePerCell=0, int *number_of_overlaps=0) const
void | resetResiduePositions (Residue *residue, list< Vector3 > &old_positions)
double | getScore ()
const std::map< Atom *, int > * | getAtomFragmentMap ()

## Protected Member Functions

AtomTypes & | getAtomTypes ()
void | setup ()
void | setAtomType (Atom *atom, const String &type_name)
double | getES ()
Protected Member Functions inherited from BALL::DiffGridBasedScoring
void | updatePrecalculatedScore (Size set)
Protected Member Functions inherited from BALL::GridBasedScoring
void | setup ()
double | calculateGridScore ()
void | defineReceptorGridSet (Vector3 &origin, Vector3 &size, double out_of_grid_penalty, bool enforce_grid_boundaries, double resolution=0.5, double interaction_no_scale=1)
std::map< String, int > * | getAtomTypesMap ()
String | getGridAtomTypeName (int grid_id)
Protected Member Functions inherited from BALL::ScoringFunction
void | setName (String name)
void | updateComponent (int id, AtomPairList *)
Vector3 | calculateGeometricalCenter (AtomContainer *s, int *no_ligand_atoms=NULL)
double | calculateMoleculeRadius (AtomContainer *sys, Vector3 &center)
void | setupFlexibleResidues_ ()
int | checkForAtomOverlaps (const AtomPairVector *pair_vector)
AtomPairVector * | createNonbondedPairVector (HashGrid3< Atom * > *hashgrid, int &overlaps, bool rec_lig, bool check_fragments=0, bool intra_fragment=0)
AtomPairVector * | createLigandNonbondedPairVector (bool intra_fragment, int &overlaps)
bool | hasPharmacophoreConstraints_ ()
void | clearStoredInteractions_ ()
double | calculateConstraintsScore ()
void | enableInteractionComponents_ (const list< String > &type_names)
void | enableAllComponents_ ()
void | fetchStaticLigandFragment (Atom *a1, int index)
int | countCovalentBonds (const Atom *atom, int threshold=-1)
virtual void | createAllLigandNonBondedPairs ()
virtual double | calculateStaticLigandFragmentEnergy ()
bool | isPeptideBond (const Bond *bond) const

## Protected Attributes

AtomTypes | atom_types_
Protected Attributes inherited from BALL::GridBasedScoring
GridSetsResult | gridsets_result_
int | combine_operation_
std::map< String, int > | atom_types_map_
std::vector< BALL::ScoreGridSet * > | grid_sets_
double | scoregrid_resolution_
bool | scoregrid_interpolation_
int | flex_gridset_id_
std::map< const Residue *, ScoreGridSet * > | flex_gridsets_
Protected Attributes inherited from BALL::ScoringFunction
String | name_ {""}
Options | options_ {}
AtomContainer * | receptor_ {nullptr}
AtomContainer * | ligand_ {nullptr}
double | score_ {0.0}
double | intercept_ {0.0}
ScoringBaseFunction * | base_function_ {nullptr}
vector< ScoringComponent * > | scoring_components_ {}
HashSet< const Atom * > | unassigned_atoms_ {}
Size | max_number_of_errors_ {0}
Size | number_of_errors_ {0}
double | ligand_radius_ {0.0}
int | ligand_atoms_ {0}
Vector3 | ligand_center_ {}
HashGrid3< Atom * > * | hashgrid_ {nullptr}
HashGrid3< Atom * > * | all_residues_hashgrid_ {nullptr}
HashGrid3< Atom * > * | static_residues_hashgrid_ {nullptr}
HashGrid3< Atom * > * | flexible_residues_hashgrid_ {nullptr}
double | resolution_ {0.0}
std::map< Atom *, int > | atoms_to_fragments_ {}
int | reference_neighbors_ {0}
int | neighboring_target_atoms_ {0}
int | misplaced_ligand_atoms_ {0}
int | hashgrid_search_radius_ {0}
double | nonbonded_cutoff_ {0.0}
double | nonbonded_cutoff_2_ {0.0}
bool | ignore_h_clashes_ {false}
int | overlaps_ {0}
int | ligand_intramol_overlaps_ {0}
double | allowed_intermolecular_overlap_ {0.0}
double | allowed_intramolecular_overlap_ {0.0}
double | neighbor_cutoff_2_ {0.0}
vector< StaticLigandFragment * > | static_ligand_fragments_ {}
bool | store_interactions_ {false}
bool | store_interactions_phC_only_ {false}
AtomPairVector * | all_ligand_nonbonded_ {nullptr}
double | conformation_scale_ {0.0}
bool | use_all_lig_nonb_ {false}
bool | use_static_lig_fragments_ {false}
int | burial_depth_scale_ {0}
double | exp_energy_stddev_ {0.0}
double | exp_energy_mean_ {0.0}
std::set< Residue * > | flexible_residues_ {}
Result | result_ {}
double | static_ligand_energy_ {0.0}
vector< Bond * > | rotatable_ligand_bonds_ {}
list< list< Vector3 > > | flexres_org_positions_ {}

## Additional Inherited Members

Static Public Member Functions inherited from BALL::ScoringFunction
static HashGrid3< Atom * > * | initializeHashGrid (AtomContainer *sys, Vector3 &center, double &resolution, int hashgrid_size)
static void | getDefaultOptions (Options &options)
Public Attributes inherited from BALL::ScoringFunction
list< Constraint * > | constraints {}
Static Public Attributes inherited from BALL::ScoringFunction
static const char * | SUBCATEGORY_NAME

## Detailed Description

ScoringFunction using a grid-based version of Piecewise Linear Potential

Definition at line 15 of file gridedPLP.h.

## Constructor & Destructor Documentation

## GridedPLP() [1/2]

BALL::GridedPLP::GridedPLP | ( | AtomContainer & | receptor,
|  | AtomContainer & | ligand,
|  | Options & | options )

## GridedPLP() [2/2]

BALL::GridedPLP::GridedPLP | ( | AtomContainer & | receptor,
|  | Vector3 & | hashgrid_origin,
|  | Options & | options )

## Member Function Documentation

## getAtomTypes()

AtomTypes & BALL::GridedPLP::getAtomTypes | ( |  | ) |

protected virtual

Implements BALL::GridBasedScoring.

## getES()

double BALL::GridedPLP::getES | ( |  | ) |

protected virtual

Reimplemented from BALL::ScoringFunction.

## setAtomType()

void BALL::GridedPLP::setAtomType | ( | Atom * | atom,
|  | const String & | type_name )

protected virtual

Set the desired type of the given atom. This function can be overloaded when setting the atom's types type is done in a different way, like for example for Gehlhaar's ScoringFunction

Reimplemented from BALL::GridBasedScoring.

## setLigand()

void BALL::GridedPLP::setLigand | ( | AtomContainer * | sys | ) |

virtual

Reimplemented from BALL::DiffGridBasedScoring.

## setup()

void BALL::GridedPLP::setup | ( |  | ) |

protected

## Member Data Documentation

## atom_types_

AtomTypes BALL::GridedPLP::atom_types_

protected

Definition at line 33 of file gridedPLP.h.